/*
hisrt.c Version 0.1.0  Hash insert record
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* return code 0 is good insert */
/* return code 1 is duplicate record */

#include <bthash.h>

int hisrt(hshhdr,rcd)
hashfmt *hshhdr;
unsigned char *rcd;
   {
   off_t ofst;
   int sigrslt;
   int rslt,lockrslt;
   unsigned char *p,*q,*r;
   unsigned char *rcdptr;
   hshhdr->reason = 0;
   sigrslt = strcmp(hshhdr->signature,H_SIGNATURE);
   if (sigrslt)
      {
      fprintf(stderr,"hisrt: non-hash "
	 "insertion\n");
      hshhdr->reason = HASH_ERR + 1011;
      return(HASH_ERR + 1011);
      } /* not a btree header */
   p = (unsigned char *) rcd
      + hshhdr->rcdhdr + hshhdr->keyofst;
   q = (unsigned char *) p + hshhdr->keylen;
   while (p < q)
      {
      if (*p != 0xff) break;
      p++;
      } /* for each byte in key */
   if (p >= q)
      {
      /* all ff */
      fprintf(stderr,"hisrt: reserved key\n");
      hshhdr->reason = HASH_ERR + 1010; 
      return(HASH_ERR + 1010); 
      } /* reserved key */
   lockrslt = lockf(hshhdr->hndl,F_TEST,0);
   if (lockrslt < 0)
      {
      return(ISRTLOCK3);
      } /* can't insert when file is locked */
   lockrslt = lockf(hshhdr->hndl,F_TLOCK,0);
   if (lockrslt < 0)
      {
      fprintf(stderr,"hisrt: lock error on %s\n",
	 hshhdr->dbname);
      perror("Lock error");
      return(ISRTLOCK4);
      } /* can't insert when file is locked */
   ofst = (off_t) hash(hshhdr,
      rcd+hshhdr->keyofst);
   hgetblk(hshhdr,ofst);
   if (hshhdr->reason) 
      return(HASH_ERR + 1001);
   rcdptr = (unsigned char *) hshhdr->node;
   rslt = 999999;
   /* for each record in chain */
   /* starting with hash data space */
   while (1)
      {
      p = (unsigned char *) rcdptr
	 + hshhdr->rcdhdr
	 + hshhdr->keyofst;
      q = (unsigned char *) p + hshhdr->keylen;
      r = (unsigned char *) rcd + hshhdr->keyofst;
      while (p < q)
	 {
	 rslt = *r - *p;
	 if (rslt) break;
	 p++;
	 r++;
	 } /* for each byte in key */
      if (!rslt)
	 {
	 fprintf(stderr,"hisrt: duplicate key\n");
	 rcd[hshhdr->rcdlen] = '\0';
	 fprintf(stderr,"%s\n", rcd);
	 if (hshhdr->lock != LOCK)
	    {
	    lockrslt = lockf(hshhdr->hndl,F_ULOCK,0);
	    if (lockrslt < 0)
	       {
	       fprintf(stderr,"hisrt: error unlocking "
	          "%s for duplicate key\n",
	          hshhdr->dbname);
	       perror("Unlock error");
	       } /* unlock err */
	    } /* if no lock in open */
	 return(ISRTDUP);
	 } /* dup rcd key */
      /* else not matched: walk chain */
      else if (hshhdr->node->next
         && hshhdr->node->next != UINT_MAX)
	 {
	 hshhdr->ofstprev = ofst;
	 ofst = hshhdr->node->next;
	 hgetblk(hshhdr,ofst);
         if (hshhdr->reason) 
            return(HASH_ERR + 1002);
         rcdptr = (unsigned char *) hshhdr->node;
	 continue;
	 } /* not duplicate key, walk chain */
      else break;
      } /* for each record in chain */
   if (hshhdr->node->next == UINT_MAX)
      {
      p = (unsigned char *) rcd;
      q = (unsigned char *) rcd + hshhdr->rcdlen;
      r = (unsigned char *) hshhdr->node + hshhdr->rcdhdr;
      while (p < q) *r++ = *p++;
      hshhdr->node->next = (off_t) 0;
      hputblk(hshhdr,
         ofst,
         hshhdr->node);
      if (hshhdr->reason) 
         return(HASH_ERR + 1003);
      } /* fill in hash part of data space */
   else
      {
      off_t ofstnext;
      hshhdr->ofstprev = ofst;
      hshhdr->freestk = hgetptr(hshhdr,hshhdr->fsofst);
      if (hshhdr->reason)
         return(HASH_ERR + 1004);
      if (hshhdr->freestk)
	 {
	 ofst = hshhdr->freestk;
	 hshhdr->freestk = hgetptr(hshhdr,ofst);
	 if (hshhdr->reason)
	    return(HASH_ERR + 1005);
         hputptr(hshhdr,hshhdr->fsofst,hshhdr->freestk);
         if (hshhdr->reason)
            return(HASH_ERR + 1006);
	 } /* if free record stack */
      else
	 {
         ofst = (off_t) hnewblk(hshhdr);
	 } /* free record stack empty */
      hgetblk(hshhdr,hshhdr->ofstprev);
      if (hshhdr->reason)
         return(HASH_ERR + 1007);
      ofstnext = hshhdr->node->next;
      hshhdr->node->next = ofst;
      hputblk(hshhdr,
         hshhdr->ofstprev,
         hshhdr->node);
      if (hshhdr->reason) 
         return(HASH_ERR + 1008);
      p = (unsigned char *) rcd;
      q = (unsigned char *) rcd + hshhdr->rcdlen;
      r = (unsigned char *) hshhdr->node + hshhdr->rcdhdr;
      while (p < q) *r++ = *p++;
      hshhdr->node->next = ofstnext;
      hputblk(hshhdr,
         ofst,
         hshhdr->node);
      if (hshhdr->reason) 
         return(HASH_ERR + 1009);
      } /* add to end of chain */
   if (hshhdr->lock != LOCK)
      {
      lockrslt = lockf(hshhdr->hndl,F_ULOCK,0);
      if (lockrslt < 0)
         {
         fprintf(stderr,"hisrt: error unlocking "
            "%s after insertion\n",
            hshhdr->dbname);
         perror("Unlock error");
         }
      } /* if no lock during open, unlock */
   return(ISRTGOOD);
   } /* hisrt */
